/*
	BinMaker program
	Copyright 2007 Jonathan Wilson
	Portions lifted from BinOpener copyright 2007 booto (temptemp91 at hotmail dot com)

	This file is part of binmaker.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	binmaker is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
#include <vector>
class ManifestItem;
struct ExtraEntry;
struct Include {
	const char *name;
	unsigned char type;
};

struct ManifestFileHeader {
	unsigned int version;
	unsigned int filesignature;
	unsigned int manifestsignature;
	unsigned int itemcount;
	unsigned int binsize;
	unsigned int maxstreamsize;
	unsigned int maxrelosize;
	unsigned int maximpsize;
	unsigned int extraentriessize;
	unsigned int includenamessize;
	unsigned int streamnamessize;
	unsigned int sourcenamessize;
};

class ManifestFile {
public:
	ManifestFileHeader Header;
	std::vector<ManifestItem *> Items;
	std::vector<Include *> Includes;
	char *Streams;
	char *Sources;
	ExtraEntry *ExtraEntries;
	unsigned int StreamPos;
	unsigned int SourcePos;
	unsigned int ExtraEntryPos;
	FILE *Manifest;
	FILE *Relo;
	FILE *Bin;
	FILE *Imp;
	unsigned int binsize;
	unsigned int maxstreamsize;
	unsigned int maxrelosize;
	unsigned int maximpsize;
	ManifestFile();
	void Save(const char *filebase);
	void AddInclude(const char *filename,unsigned char type);
};
